diff --git a/src/test/recovery/t/016_min_consistency.pl b/src/test/recovery/t/016_min_consistency.pl
index 8f1a89c2d3..90a270650d 100644
--- a/src/test/recovery/t/016_min_consistency.pl
+++ b/src/test/recovery/t/016_min_consistency.pl
@@ -97,6 +97,10 @@ INSERT INTO test1 SELECT generate_series(1, 10000);");
 $primary->safe_psql('postgres', 'CHECKPOINT;');
 $primary->safe_psql('postgres', 'UPDATE test1 SET a = a + 1;');
 
+# Wait for table creation to happen on the standby.
+$primary->wait_for_catchup($standby, 'replay',
+			   $primary->lsn('insert'));
+
 # Fill in the standby's shared buffers with the data filled in
 # previously.
 $standby->safe_psql('postgres', 'SELECT count(*) FROM test1;');
